﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace fieldsBinding
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            tg.DataContext = new ViewModel();
        }

        private void tg_FieldLayoutInitializing(object sender, Infragistics.Windows.DataPresenter.Events.FieldLayoutInitializingEventArgs e)
        {
            if ((string)e.FieldLayout.Key == "Person")
                e.FieldLayout.Fields["Orders"].DataType = typeof(IEnumerable);

        }
    }

    public class Person
    {
         public string Id { get; set; }
    
         public string Name { get; set; }

        public List<Order> Orders { get; set; }

    }

  
    public class Order
   {

        public string Id { get; set; }

        public string Name { get; set; }
   }

    public class Wrapper<T>
    {
      public  T Data { get; set; }
    }

    public class ViewModel
    {
        public ViewModel()
        {
            #region collection
            collection = new ObservableCollection<Wrapper<Person>>();
            collection.Add(new Wrapper<Person>
            {
                Data = new Person()
                {
                    Id = "1",
                    Name = "Name1",
                    Orders = new List<Order>()
                   {
                       new Order()
                       {
                           Id = "1.1",
                           Name = "Name 1.1"
                       }
    
                   }
                }

            });

            collection.Add(new Wrapper<Person>
            {
                Data = new Person()
                {
                    Id = "2",
                    Name = "Name2",
                    Orders = new List<Order>()
                   {
                       new Order()
                       {
                           Id = "2.1",
                           Name = "Name 2.2"
                       }
    
                   }
                }

            });

            #endregion
        }
        public ObservableCollection<Wrapper<Person>> collection { get; set; }
    }
}
